diff -Naur rpm-specs.orig/bitstream-vera-fonts.spec rpm-specs/bitstream-vera-fonts.spec
--- rpm-specs.orig/bitstream-vera-fonts.spec	2024-04-04 04:01:29.000000000 +0200
+++ rpm-specs/bitstream-vera-fonts.spec	2024-04-05 09:09:25.602039908 +0200
@@ -1,7 +1,7 @@
 # SPDX-License-Identifier: MIT
 Version: 1.10
-Release: 50%{?dist}
-License: Bitstream Vera
+Release: 51%{?dist}
+License: Bitstream-Vera
 URL:     http://www.gnome.org/fonts/
 
 BuildArch: noarch
@@ -88,6 +88,9 @@
 %fontfiles -a
 
 %changelog
+* Fri Apr 05 2024 Miroslav Suchý <msuchy@redhat.com> - 1.10-51
+- convert license to SPDX
+
 * Tue Jan 23 2024 Fedora Release Engineering <releng@fedoraproject.org> - 1.10-50
 - Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild
 
diff -Naur rpm-specs.orig/bpg-fonts.spec rpm-specs/bpg-fonts.spec
--- rpm-specs.orig/bpg-fonts.spec	2024-02-21 03:02:00.000000000 +0100
+++ rpm-specs/bpg-fonts.spec	2024-04-05 09:09:27.174053011 +0200
@@ -7,7 +7,7 @@
 Name:		%{fontname}-fonts
 Summary: 	Georgian Unicode fonts
 Version:	%{common_ver}
-Release:	25%{?dist}
+Release:	26%{?dist}
 # Font exception
 # See: http://groups.google.com/group/bpg-fonts/web/gpl-gnu-license
 # No version of the GPL is specified.
@@ -196,7 +196,7 @@
 %package -n %{fontname}-dejavu-sans-fonts
 Summary:	DejaVu Sans with BPG Georgian changes
 Version:	2017.2.005
-License:	Bitstream Vera
+License:	Bitstream-Vera
 Requires:	%{name}-common = %{common_ver}-%{release}
 
 %description -n %{fontname}-dejavu-sans-fonts
@@ -211,7 +211,7 @@
 %package -n %{fontname}-dejavu-sans-mono-fonts
 Summary:	DejaVu Sans Mono with BPG Georgian changes
 Version:	2017.3.003
-License:	Bitstream Vera
+License:	Bitstream-Vera
 Requires:	%{name}-common = %{common_ver}-%{release}
 
 %description -n %{fontname}-dejavu-sans-mono-fonts
@@ -226,7 +226,7 @@
 %package -n %{fontname}-dejavu-serif-fonts
 Summary:	DejaVu Serif with BPG Georgian changes
 Version:	2017.2.37
-License:	Bitstream Vera
+License:	Bitstream-Vera
 Requires:	%{name}-common = %{common_ver}-%{release}
 
 %description -n %{fontname}-dejavu-serif-fonts
@@ -256,7 +256,7 @@
 Summary:	Excelsior family of BPG Georgian fonts
 Version:	2.03
 Requires:	%{name}-common = %{common_ver}-%{release}
-License:	Bitstream Vera
+License:	Bitstream-Vera
 
 %description -n %{fontname}-excelsior-fonts
 %common_desc
@@ -270,7 +270,7 @@
 Summary:	Excelsior Caps family of BPG Georgian fonts
 Version:	2.003
 Requires:	%{name}-common = %{common_ver}-%{release}
-License:	Bitstream Vera
+License:	Bitstream-Vera
 
 %description -n %{fontname}-excelsior-caps-fonts
 %common_desc
@@ -284,7 +284,7 @@
 Summary:	Excelsior Condenced family of BPG Georgian fonts
 Version:	2.003
 Requires:	%{name}-common = %{common_ver}-%{release}
-License:	Bitstream Vera
+License:	Bitstream-Vera
 
 %description -n %{fontname}-excelsior-condenced-fonts
 %common_desc
@@ -489,7 +489,7 @@
 %package -n %{fontname}-sans-modern-fonts
 Summary:	Sans Modern family of BPG Georgian fonts
 Version:	2.025
-License:	Bitstream Vera
+License:	Bitstream-Vera
 Requires:	%{name}-common = %{common_ver}-%{release}
 
 %description -n	%{fontname}-sans-modern-fonts
@@ -529,7 +529,7 @@
 %package -n %{fontname}-serif-modern-fonts
 Summary:	Serif Modern family of BPG Georgian fonts
 Version:	2.028
-License:	Bitstream Vera
+License:	Bitstream-Vera
 Requires:	%{name}-common = %{common_ver}-%{release}
 
 %description -n %{fontname}-serif-modern-fonts
@@ -708,6 +708,9 @@
 %doc Docs/*
 
 %changelog
+* Fri Apr  5 2024 Miroslav Suchý <msuchy@redhat.com> - 3.300-26
+- convert license to SPDX
+
 * Tue Jan 23 2024 Fedora Release Engineering <releng@fedoraproject.org> - 20120413-25
 - Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild
 
diff -Naur rpm-specs.orig/R-fontBitstreamVera.spec rpm-specs/R-fontBitstreamVera.spec
--- rpm-specs.orig/R-fontBitstreamVera.spec	2024-01-23 03:39:54.000000000 +0100
+++ rpm-specs/R-fontBitstreamVera.spec	2024-04-05 09:09:28.162061246 +0200
@@ -4,10 +4,10 @@
 
 Name:             R-%{packname}
 Version:          0.1.1
-Release:          20%{?dist}
+Release:          21%{?dist}
 Summary:          Fonts with 'Bitstream Vera Fonts' License
 
-License:          Bitstream Vera
+License:          Bitstream-Vera
 URL:              https://CRAN.R-project.org/package=%{packname}
 Source0:          https://cran.r-project.org/src/contrib/%{packname}_%{packver}.tar.gz
 
@@ -86,6 +86,9 @@
 
 
 %changelog
+* Fri Apr  5 2024 Miroslav Suchý <msuchy@redhat.com> - 0.1.1-21
+- convert license to SPDX
+
 * Mon Jan 22 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.1.1-20
 - Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild
 