From 018bf8e7ca32a45b040b50bde0461d4dac3f9b31 Mon Sep 17 00:00:00 2001
From: Colin Walters <walters@verbum.org>
Date: Tue, 23 Mar 2010 08:47:48 -0400
Subject: [PATCH 1/4] Delete all optional components from @gnome-desktop

Optional components are currently only visible from the UI
in Standalone Anaconda, and are a random grab bag of

* Applications
* System administration tools
* Desktop UI replacement
* Other arbitrary software that links to gtk2 and gconf

Going through this list:
Applications:
  Now browseable in packagedb
System admin tools:
  Should move into the Fedora Deployment Guide probably
Desktop UI replacement:
  I don't think we should (or need to) advertise these.
  People who want them either know how to get them, or
  are going to follow instructions from an upstream
  wiki page.
Other arbitrary software:
  Just no.
---
 comps-f13.xml.in |   76 ------------------------------------------------------
 comps-f14.xml.in |   76 ------------------------------------------------------
 2 files changed, 0 insertions(+), 152 deletions(-)

diff --git a/comps-f13.xml.in b/comps-f13.xml.in
index f9658fc..53d74f7 100644
--- a/comps-f13.xml.in
+++ b/comps-f13.xml.in
@@ -2642,82 +2642,6 @@
       <packagereq type="default">vino</packagereq>
       <packagereq type="default">xdg-user-dirs-gtk</packagereq>
       <packagereq type="default">zenity</packagereq>
-      <packagereq type="optional">alacarte</packagereq>
-      <packagereq type="optional">avant-window-navigator</packagereq>
-      <packagereq type="optional">beagle-evolution</packagereq>
-      <packagereq type="optional">beagle-gnome</packagereq>
-      <packagereq type="optional">buoh</packagereq>
-      <packagereq type="optional">byzanz</packagereq>
-      <packagereq type="optional">control-center-extra</packagereq>
-      <packagereq type="optional">dasher</packagereq>
-      <packagereq type="optional">deskbar-applet</packagereq>
-      <packagereq type="optional">esc</packagereq>
-      <packagereq type="optional">evince-djvu</packagereq>
-      <packagereq type="optional">evince-dvi</packagereq>
-      <packagereq type="optional">file-browser-applet</packagereq>
-      <packagereq type="optional">gconf-editor</packagereq>
-      <packagereq type="optional">gdesklets</packagereq>
-      <packagereq type="optional">gedit-plugins</packagereq>
-      <packagereq type="optional">glipper</packagereq>
-      <packagereq type="optional">glunarclock</packagereq>
-      <packagereq type="optional">gmpc</packagereq>
-      <packagereq type="optional">gmrun</packagereq>
-      <packagereq type="optional">gnochm</packagereq>
-      <packagereq type="optional">gnome-applet-alarm-clock</packagereq>
-      <packagereq type="optional">gnome-applet-bubblemon</packagereq>
-      <packagereq type="optional">gnome-applet-cpufire</packagereq>
-      <packagereq type="optional">gnome-applet-music</packagereq>
-      <packagereq type="optional">gnome-applet-netspeed</packagereq>
-      <packagereq type="optional">gnome-applet-sensors</packagereq>
-      <packagereq type="optional">gnome-applet-timer</packagereq>
-      <packagereq type="optional">gnome-commander</packagereq>
-      <packagereq type="optional">gnome-device-manager</packagereq>
-      <packagereq type="optional">gnome-media-apps</packagereq>
-      <packagereq type="optional">gnome-netstatus</packagereq>
-      <packagereq type="optional">gnome-phone-manager</packagereq>
-      <packagereq type="optional">gnome-pilot-conduits</packagereq>
-      <packagereq type="optional">gnome-schedule</packagereq>
-      <packagereq type="optional">gnome-system-log</packagereq>
-      <packagereq type="optional">gnome-theme-curvylooks</packagereq>
-      <packagereq type="optional">gnotime</packagereq>
-      <packagereq type="optional">gonvert</packagereq>
-      <packagereq type="optional">grsync</packagereq>
-      <packagereq type="optional">gst-mixer</packagereq>
-      <packagereq type="optional">gthumb</packagereq>
-      <packagereq type="optional">gtrayicon</packagereq>
-      <packagereq type="optional">gtweakui</packagereq>
-      <packagereq type="optional">gvfs-obexftp</packagereq>
-      <packagereq type="optional">hamster-applet</packagereq>
-      <packagereq type="optional">istanbul</packagereq>
-      <packagereq type="optional">lock-keys-applet</packagereq>
-      <packagereq type="optional">nautilus-actions</packagereq>
-      <packagereq type="optional">nautilus-image-converter</packagereq>
-      <packagereq type="optional">nautilus-open-terminal</packagereq>
-      <packagereq type="optional">nautilus-search-tool</packagereq>
-      <packagereq type="optional">nautilus-sound-converter</packagereq>
-      <packagereq type="optional">panelfm</packagereq>
-      <packagereq type="optional">pcmanfm</packagereq>
-      <packagereq type="optional">preferences-menus</packagereq>
-      <packagereq type="optional">pulseaudio-esound-compat</packagereq>
-      <packagereq type="optional">qtcurve-gtk2</packagereq>
-      <packagereq type="optional">rss-glx-gnome-screensaver</packagereq>
-      <packagereq type="optional">sabayon</packagereq>
-      <packagereq type="optional">scim-gtk</packagereq>
-      <packagereq type="optional">screenruler</packagereq>
-      <packagereq type="optional">seahorse-plugins</packagereq>
-      <packagereq type="optional">stardict-dic-en</packagereq>
-      <packagereq type="optional">swfdec-gnome</packagereq>
-      <packagereq type="optional">tango-icon-theme</packagereq>
-      <packagereq type="optional">tango-icon-theme-extras</packagereq>
-      <packagereq type="optional">themes-backgrounds-gnome</packagereq>
-      <packagereq type="optional">tomboy</packagereq>
-      <packagereq type="optional">tracker-search-tool</packagereq>
-      <packagereq type="optional">verbiste-gnome</packagereq>
-      <packagereq type="optional">wallpapoz</packagereq>
-      <packagereq type="optional">wp_tray</packagereq>
-      <packagereq type="optional">xiphos</packagereq>
-      <packagereq type="optional">xscreensaver-extras-gss</packagereq>
-      <packagereq type="optional">xscreensaver-gl-extras-gss</packagereq>
     </packagelist>
   </group>
   <group>
diff --git a/comps-f14.xml.in b/comps-f14.xml.in
index 3bbd244..48b01ed 100644
--- a/comps-f14.xml.in
+++ b/comps-f14.xml.in
@@ -2637,82 +2637,6 @@
       <packagereq type="default">vino</packagereq>
       <packagereq type="default">xdg-user-dirs-gtk</packagereq>
       <packagereq type="default">zenity</packagereq>
-      <packagereq type="optional">alacarte</packagereq>
-      <packagereq type="optional">avant-window-navigator</packagereq>
-      <packagereq type="optional">beagle-evolution</packagereq>
-      <packagereq type="optional">beagle-gnome</packagereq>
-      <packagereq type="optional">buoh</packagereq>
-      <packagereq type="optional">byzanz</packagereq>
-      <packagereq type="optional">control-center-extra</packagereq>
-      <packagereq type="optional">dasher</packagereq>
-      <packagereq type="optional">deskbar-applet</packagereq>
-      <packagereq type="optional">esc</packagereq>
-      <packagereq type="optional">evince-djvu</packagereq>
-      <packagereq type="optional">evince-dvi</packagereq>
-      <packagereq type="optional">file-browser-applet</packagereq>
-      <packagereq type="optional">gconf-editor</packagereq>
-      <packagereq type="optional">gdesklets</packagereq>
-      <packagereq type="optional">gedit-plugins</packagereq>
-      <packagereq type="optional">glipper</packagereq>
-      <packagereq type="optional">glunarclock</packagereq>
-      <packagereq type="optional">gmpc</packagereq>
-      <packagereq type="optional">gmrun</packagereq>
-      <packagereq type="optional">gnochm</packagereq>
-      <packagereq type="optional">gnome-applet-alarm-clock</packagereq>
-      <packagereq type="optional">gnome-applet-bubblemon</packagereq>
-      <packagereq type="optional">gnome-applet-cpufire</packagereq>
-      <packagereq type="optional">gnome-applet-music</packagereq>
-      <packagereq type="optional">gnome-applet-netspeed</packagereq>
-      <packagereq type="optional">gnome-applet-sensors</packagereq>
-      <packagereq type="optional">gnome-applet-timer</packagereq>
-      <packagereq type="optional">gnome-commander</packagereq>
-      <packagereq type="optional">gnome-device-manager</packagereq>
-      <packagereq type="optional">gnome-media-apps</packagereq>
-      <packagereq type="optional">gnome-netstatus</packagereq>
-      <packagereq type="optional">gnome-phone-manager</packagereq>
-      <packagereq type="optional">gnome-pilot-conduits</packagereq>
-      <packagereq type="optional">gnome-schedule</packagereq>
-      <packagereq type="optional">gnome-system-log</packagereq>
-      <packagereq type="optional">gnome-theme-curvylooks</packagereq>
-      <packagereq type="optional">gnotime</packagereq>
-      <packagereq type="optional">gonvert</packagereq>
-      <packagereq type="optional">grsync</packagereq>
-      <packagereq type="optional">gst-mixer</packagereq>
-      <packagereq type="optional">gthumb</packagereq>
-      <packagereq type="optional">gtrayicon</packagereq>
-      <packagereq type="optional">gtweakui</packagereq>
-      <packagereq type="optional">gvfs-obexftp</packagereq>
-      <packagereq type="optional">hamster-applet</packagereq>
-      <packagereq type="optional">istanbul</packagereq>
-      <packagereq type="optional">lock-keys-applet</packagereq>
-      <packagereq type="optional">nautilus-actions</packagereq>
-      <packagereq type="optional">nautilus-image-converter</packagereq>
-      <packagereq type="optional">nautilus-open-terminal</packagereq>
-      <packagereq type="optional">nautilus-search-tool</packagereq>
-      <packagereq type="optional">nautilus-sound-converter</packagereq>
-      <packagereq type="optional">panelfm</packagereq>
-      <packagereq type="optional">pcmanfm</packagereq>
-      <packagereq type="optional">preferences-menus</packagereq>
-      <packagereq type="optional">pulseaudio-esound-compat</packagereq>
-      <packagereq type="optional">qtcurve-gtk2</packagereq>
-      <packagereq type="optional">rss-glx-gnome-screensaver</packagereq>
-      <packagereq type="optional">sabayon</packagereq>
-      <packagereq type="optional">scim-gtk</packagereq>
-      <packagereq type="optional">screenruler</packagereq>
-      <packagereq type="optional">seahorse-plugins</packagereq>
-      <packagereq type="optional">stardict-dic-en</packagereq>
-      <packagereq type="optional">swfdec-gnome</packagereq>
-      <packagereq type="optional">tango-icon-theme</packagereq>
-      <packagereq type="optional">tango-icon-theme-extras</packagereq>
-      <packagereq type="optional">themes-backgrounds-gnome</packagereq>
-      <packagereq type="optional">tomboy</packagereq>
-      <packagereq type="optional">tracker-search-tool</packagereq>
-      <packagereq type="optional">verbiste-gnome</packagereq>
-      <packagereq type="optional">wallpapoz</packagereq>
-      <packagereq type="optional">wp_tray</packagereq>
-      <packagereq type="optional">xiphos</packagereq>
-      <packagereq type="optional">xscreensaver-extras-gss</packagereq>
-      <packagereq type="optional">xscreensaver-gl-extras-gss</packagereq>
     </packagelist>
   </group>
   <group>
-- 
1.6.6.1