From 122bd2f145bf5892985352f84b5aacb334654cf0 Mon Sep 17 00:00:00 2001
From: Colin Walters <walters@verbum.org>
Date: Tue, 23 Mar 2010 09:14:04 -0400
Subject: [PATCH] Rename fedora-livecd-desktop to fedora-live-desktop.ks, add -cd.ks

The old fedora-livecd-desktop.ks was conflating two entirely different
things:

* A live-based image which can be used to install
* Fitting onto a CD

Split up these two concepts so that fedora-live-desktop is *THE*
desktop.  What we expect everyone to have as a base, and the
exact same set of packages should be installed by Standalone
Anaconda (DVD) as well.  Then, we have minimization hacks
in fedora-live-desktop-cd.ks.

Over time, we should be shrinking the default install and making
it more just-in-time, by e.g. having many more things use
the PackageKit library to pull in components as needed.
---
 fedora-live-desktop-cd.ks |   57 ++++++++++++++++++++++++
 fedora-live-desktop.ks    |   54 +++++++++++++++++++++++
 fedora-livecd-desktop.ks  |  107 ---------------------------------------------
 3 files changed, 111 insertions(+), 107 deletions(-)
 create mode 100644 fedora-live-desktop-cd.ks
 create mode 100644 fedora-live-desktop.ks
 delete mode 100644 fedora-livecd-desktop.ks

diff --git a/fedora-live-desktop-cd.ks b/fedora-live-desktop-cd.ks
new file mode 100644
index 0000000..e14e5a0
--- /dev/null
+++ b/fedora-live-desktop-cd.ks
@@ -0,0 +1,57 @@
+# Desktop with customizationst to fit in a CD sized image (package removals, etc.)
+# Maintained by the Fedora Desktop SIG:
+# http://fedoraproject.org/wiki/SIGs/Desktop
+# mailto:fedora-desktop-list@fedoraproject.org
+
+%include fedora-live-desktop.ks
+
+%packages
+# dictionaries are big
+-aspell-*
+-hunspell-*
+-man-pages*
+-words
+
+# save some space
+-gnome-user-docs
+-evolution-help
+-gnome-games-help
+-nss_db
+-isdn4k-utils
+-desktop-backgrounds-basic
+-constantine-backgrounds-extras
+
+# things we don't need here
+-seahorse
+-alacarte
+-krb5-auth-dialog
+-krb5-workstation
+-pam_krb5
+-quota
+-acpid
+-nano
+-smartmontools
+-minicom
+-dos2unix
+-finger
+-ftp
+-jwhois
+-mtr
+-pinfo
+-rsh
+-telnet
+-unix2dos
+-nfs-utils
+-ypbind
+-yp-tools
+-rpcbind
+
+# drop some system-config things
+-system-config-boot
+-system-config-language
+-system-config-lvm
+-system-config-network
+-system-config-rootpassword
+-system-config-services
+-policycoreutils-gui
+%end
diff --git a/fedora-live-desktop.ks b/fedora-live-desktop.ks
new file mode 100644
index 0000000..2e31f29
--- /dev/null
+++ b/fedora-live-desktop.ks
@@ -0,0 +1,54 @@
+# Maintained by the Fedora Desktop SIG:
+# http://fedoraproject.org/wiki/SIGs/Desktop
+# mailto:fedora-desktop-list@fedoraproject.org
+
+%include fedora-live-base.ks
+
+%packages
+@graphical-internet
+@sound-and-video
+@gnome-desktop
+@office
+
+# FIXME - these two need to go in comps
+nss-mdns
+# use the PackageKit helper for bash
+PackageKit-command-not-found
+
+# avoid weird case where we pull in more festival stuff than we need
+festival
+festvox-slt-arctic-hts
+
+%end
+
+%post
+cat >> /etc/rc.d/init.d/livesys << EOF
+# disable screensaver locking
+gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t bool /apps/gnome-screensaver/lock_enabled false >/dev/null
+gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t bool /desktop/gnome/lockdown/disable_lock_screen true >/dev/null
+
+# set up timed auto-login for after 60 seconds
+cat >> /etc/gdm/custom.conf << FOE
+[daemon]
+TimedLoginEnable=true
+TimedLogin=liveuser
+TimedLoginDelay=60
+FOE
+
+# Show harddisk install on the desktop
+sed -i -e 's/NoDisplay=true/NoDisplay=false/' /usr/share/applications/liveinst.desktop
+mkdir /home/liveuser/Desktop
+cp /usr/share/applications/liveinst.desktop /home/liveuser/Desktop
+chown -R liveuser.liveuser /home/liveuser/Desktop
+chmod a+x /home/liveuser/Desktop/liveinst.desktop
+
+# But not trash and home
+gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t bool /apps/nautilus/desktop/trash_icon_visible false >/dev/null
+gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t bool /apps/nautilus/desktop/home_icon_visible false >/dev/null
+
+# Turn off PackageKit-command-not-found while uninstalled
+sed -i -e 's/^SoftwareSourceSearch=true/SoftwareSourceSearch=false/' /etc/PackageKit/CommandNotFound.conf
+
+EOF
+
+%end
diff --git a/fedora-livecd-desktop.ks b/fedora-livecd-desktop.ks
deleted file mode 100644
index 9d78fc5..0000000
--- a/fedora-livecd-desktop.ks
+++ /dev/null
@@ -1,107 +0,0 @@
-# Maintained by the Fedora Desktop SIG:
-# http://fedoraproject.org/wiki/SIGs/Desktop
-# mailto:fedora-desktop-list@redhat.com
-
-## NOTE:
-# This file should in general be *subtraction* from the gnome-desktop
-# comps group to fit within a CD-sized image.  If you want to add
-# a package to the desktop, add them to the comps group.
-
-%include fedora-live-base.ks
-
-%packages
-@graphical-internet
-@sound-and-video
-@gnome-desktop
-@office
-nss-mdns
-
-# avoid weird case where we pull in more festival stuff than we need
-festival
-festvox-slt-arctic-hts
-
-# dictionaries are big
--aspell-*
--hunspell-*
--man-pages*
--words
-
-# save some space
--gnome-user-docs
--evolution-help
--gnome-games-help
--nss_db
--isdn4k-utils
--desktop-backgrounds-basic
--constantine-backgrounds-extras
-
-# things we don't need here
--seahorse
--alacarte
--krb5-auth-dialog
--krb5-workstation
--pam_krb5
--quota
--acpid
--nano
--smartmontools
--minicom
--dos2unix
--finger
--ftp
--jwhois
--mtr
--pinfo
--rsh
--telnet
--unix2dos
--nfs-utils
--ypbind
--yp-tools
--rpcbind
-
-# drop some system-config things
--system-config-boot
--system-config-language
--system-config-lvm
--system-config-network
--system-config-rootpassword
--system-config-services
--policycoreutils-gui
-
-# use the PackageKit helper for bash
-PackageKit-command-not-found
-
-%end
-
-%post
-cat >> /etc/rc.d/init.d/livesys << EOF
-# disable screensaver locking
-gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t bool /apps/gnome-screensaver/lock_enabled false >/dev/null
-gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t bool /desktop/gnome/lockdown/disable_lock_screen true >/dev/null
-
-# set up timed auto-login for after 60 seconds
-cat >> /etc/gdm/custom.conf << FOE
-[daemon]
-TimedLoginEnable=true
-TimedLogin=liveuser
-TimedLoginDelay=60
-FOE
-
-# Show harddisk install on the desktop
-sed -i -e 's/NoDisplay=true/NoDisplay=false/' /usr/share/applications/liveinst.desktop
-mkdir /home/liveuser/Desktop
-cp /usr/share/applications/liveinst.desktop /home/liveuser/Desktop
-chown -R liveuser.liveuser /home/liveuser/Desktop
-chmod a+x /home/liveuser/Desktop/liveinst.desktop
-
-# But not trash and home
-gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t bool /apps/nautilus/desktop/trash_icon_visible false >/dev/null
-gconftool-2 --direct --config-source=xml:readwrite:/etc/gconf/gconf.xml.defaults -s -t bool /apps/nautilus/desktop/home_icon_visible false >/dev/null
-
-# Turn off PackageKit-command-not-found while uninstalled
-sed -i -e 's/^SoftwareSourceSearch=true/SoftwareSourceSearch=false/' /etc/PackageKit/CommandNotFound.conf
-
-EOF
-
-%end
-- 
1.6.6.1